/*********       ALL THE PATHS BETWEEN TWO VERTICES      **********/
/*********    ON A  COMPLETE   GRAPH   4WITH N VERTICES   *********/
/*********                             Fig. 29-13                                                   *********/

#include <SDL/SDL.h>
#include <math.h>
#include <stdio.h>
#define YES 1
#define NO 0
#define r 29.
#define N 6    /** can be changed */
void pause(void);
void putpixel(int xe, int ye, Uint32 color);
Uint32 getpixel(int xe, int ye);
void circle( int xo, int yo, int R, Uint32 color);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int width,Uint32 c);
void path(int i,int level);
int belonginglistofpredecessors(int j, int level);
int predecessor[N+1];  /** N+1 corresponds to number of levels*/
int xorig,yorig;int start,end,nbv[N],v[N][N],x[N],y[N],number;
SDL_Surface * screen; Uint32 white,blue,red;

int main(int argc, char ** argv)
{   int i,j;int c,fact; float e;
    SDL_Init(SDL_INIT_VIDEO);
    screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
    white=SDL_MapRGB(screen->format,255,255,255);
    blue=SDL_MapRGB(screen->format,0,0,255);
    red=SDL_MapRGB(screen->format,255,0,0);
    SDL_FillRect(screen,0,white);

    for(i=0;i<N;i++) {x[i]=r*cos(2.*M_PI*i/(float)N);y[i]=r*sin(2.*M_PI*i/(float)N);}
    start=0;end=N/2;number=0; xorig=5+r;yorig=5+r;  path(start,0);
    printf("%d ",number);
    /**  theoretical calculus  */
    fact=1;
    for(i=2;i<=N-2;i++)  fact=i*fact;
    e=exp(1);c=1;
    for(i=3;i<=N;i++) c=(i-2)*c+1;
    printf("  %d   %3.1f  ",c, e*fact);
    SDL_Flip(screen);pause(); return 0;
}

void path(int i,int level)
{
int j,k;
if (i==end)
   { number++;
     for(i=0;i<N;i++) for(j=0;j<N;j++)if (i!=j)
     line(xorig+x[i],yorig-y[i],xorig+x[j],yorig-y[j],blue);
     for(k=1;k<level;k++)
     linewithwidth(xorig+x[predecessor[k]],yorig-y[predecessor[k]],
                         xorig+x[predecessor[k+1]],yorig-y[predecessor[k+1]],1,red);
     linewithwidth(xorig+x[predecessor[level]],
                         yorig-y[predecessor[level]],xorig+x[end],yorig-y[end],1,red);
     xorig+=5+2*r; if (xorig>750)  {yorig+=10+2*r;xorig=5+r; }
     if (yorig>550) { SDL_Flip(screen); pause();SDL_FillRect(screen,0,white);
                              xorig=5+r; yorig=10+2*r;}
   }
else
  {
  for(j=0;j<N;j++) if (j!=i)
  if ( belonginglistofpredecessors(j,level)==NO)
	 { predecessor[level+1]=i; path(j,level+1); }
  }
}

int belonginglistofpredecessors(int j, int level)
{
int k;
for(k=level;k>=1;k--)  if (j==predecessor[k]) return YES;
return NO;
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 color)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=color;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}

void circle( int xo, int yo, int R, Uint32 color)
  {
      int x, y, F, F1, F2,newx,newy;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,color);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, color);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,color);
              newx=2*xo-x ; newy=2*yo-y ;
             if (x<800 && x>=0 && newy>=0 && newy<600) putpixel(x, newy,color);
             if (newx<800 && newx>=0 && y>=0 && y<600) putpixel( newx,y,color);
             if (newx<800 && newx>=0 && newy>=0 && newy<600) putpixel(newx,
             newy, color);
         }
       if (xo+R<800 && xo+R>=0) putpixel(xo+R,yo,color);
       if (xo-R<800 && xo-R>=0) putpixel(xo-R,yo, color);
  }

void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,pasx,pasy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  putpixel(x,y,c);
if (dx>0) pasx=1;else pasx=-1; if (dy>0) pasy=1; else pasy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=pasy;
                                                    putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=pasx;
                                                         putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=pasx; y+=pasy;
                                     putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=pasx; residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=pasy;}
			     putpixel(x,y,c);
			  }
else for(i=0;i<absdy;i++)
             {y+=pasy; residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=pasx;}
              putpixel(x,y,c);
             }
}

void linewithwidth(int x1, int y1, int x2, int y2, int width,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est step nul */
{ dx1=(float)width*(float)dx/d; dy1=(float)width*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}



